﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.Text.RegularExpressions;

namespace XLinq
{
    class Program
    {
        static void Main(string[] args)
        {
            // Hack Region settings
            System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");

            #region Step 1 - Create Element
            //XElement contacts =
            //        new XElement("contacts",
            //            new XElement("contact",
            //                new XElement("name", "Patrick Hines"),
            //                new XElement("phone", "206-555-0144",
            //                new XAttribute("type", "home")),
            //                new XElement("phone", "425-555-0145",
            //                new XAttribute("type", "work")),
            //                new XElement("address",
            //                    new XElement("street1", "123 Main St"),
            //                    new XElement("city", "Mercer Island"),
            //                    new XElement("state", "WA"),
            //                    new XElement("postal", "68042")
            //                )
            //            )
            //        );

            //Console.WriteLine(contacts); 
            #endregion

            #region Step 2 - Create Document
            //XDocument contactsDoc =
            //                    new XDocument(
            //                        new XDeclaration("1.0", "utf-8", "yes"),
            //                        new XComment("LINQ to XML Contacts XML Example"),
            //                        new XProcessingInstruction("MyApp", "123-44-4444"),
            //                        contacts
            //                    );

            //contactsDoc.Save("contacts.xml"); 
            #endregion

            #region Step 3 - Create Element with Namespace
             //XElement contacts = new XElement("{http://myCompany.com}contacts", … );

            //XNamespace myNs = "http://mycompany.com";

            //XElement contacts =
            //    new XElement(myNs + "contacts",
            //        new XElement(myNs + "contact",
            //            new XElement(myNs + "name", "Patrick Hines"),
            //            new XElement(myNs + "phone", "206-555-0144",
            //            new XAttribute("type", "home")),
            //            new XElement(myNs + "phone", "425-555-0145",
            //            new XAttribute("type", "work")),
            //            new XElement(myNs + "address",
            //                new XElement(myNs + "street1", "123 Main St"),
            //                new XElement(myNs + "city", "Mercer Island"),
            //                new XElement(myNs + "state", "WA"),
            //                new XElement(myNs + "postal", "68042")
            //            )
            //        )
            //    );
            //Console.WriteLine(contacts); 
            #endregion

            #region Step 4 - Namespace witf Prefix
            //XNamespace ns = "http://mycompany.com";
            //XElement e =
            //    new XElement(ns + "e",
            //    new XAttribute(XNamespace.Xmlns + "p", ns)
            //);
            //Console.WriteLine(e); 
            #endregion

            #region Step 5 - Read XML from String
//            XElement contacts = XElement.Parse(
//                       @"<contacts>
//                      <contact>
//                         <name>Patrick Hines</name>
//                         <phone type=""home"">206-555-0144</phone>
//                         <phone type=""work"">425-555-0145</phone>
//                         <address>
//                            <street1>123 Main St</street1>
//                            <city>Mercer Island</city>         
//                            <state>WA</state>
//                            <postal>68042</postal>
//                         </address>
//                         <netWorth>10</netWorth>
//                      </contact>
//                      <contact>
//                         <name>Gretchen Rivas</name>
//                         <phone type=""mobile"">206-555-0163</phone>
//                         <address>
//                            <street1>123 Main St</street1>
//                            <city>Mercer Island</city>
//                            <state>WA</state>
//                            <postal>68042</postal>
//                         </address>
//                         <netWorth>11</netWorth>
//                      </contact>
//                      <contact>
//                         <name>Scott MacDonald</name>
//                         <phone type=""home"">925-555-0134</phone>
//                         <phone type=""mobile"">425-555-0177</phone>
//                         <address>
//                            <street1>345 Stewart St</street1>
//                            <city>Chatsworth</city>
//                            <state>CA</state>
//                            <postal>91746</postal>
//                         </address>
//                         <netWorth>500000</netWorth>
//                      </contact>
//                   </contacts>");
//            Console.WriteLine(contacts); 
            #endregion

            #region Step 6 - Read XML from File
            //XElement contacts = XElement.Load("contacts.xml");
            //Console.WriteLine(contacts); 
            #endregion

            #region Step 7 - Element from IEnumerable            
            #region Object Initializers
            //var persons = new[] {
            //       new Person {
            //          Name = "Patrick Hines",
            //          PhoneNumbers = new[] { "206-555-0144", "425-555-0145" }
            //       },
            //       new Person {
            //          Name = "Gretchen Rivas",
            //          PhoneNumbers = new[] { "206-555-0163" }
            //       }
            //};

           

            #region Create from IEnumerable
            //XElement contacts =
            //       new XElement("contacts",
            //          from p in persons // Query expressions
            //          select new XElement("contact",
            //             new XElement("name", p.Name),
            //             from ph in p.PhoneNumbers
            //             select new XElement("phone", ph)
            //          )
            //       );
            //Console.WriteLine(contacts); 
            #endregion
            #endregion
            #endregion

            #region Step 8 - Traversing XElement
//            XElement contact = XElement.Parse(@"<contact>
//                   Met in 2005.
//                   <name>Patrick Hines</name>
//                   <phone>206-555-0144</phone>
//                   <phone>425-555-0145</phone>
//                   <!--Avoid whenever possible-->
//                </contact>");

//            Console.WriteLine("All nodes");
//            Console.WriteLine("-------------------");
//            foreach (var c in contact.Nodes())
//            {
//                Console.WriteLine(c);
//                //Console.WriteLine(c.GetType());
//            }
//            Console.WriteLine("-------------------");
//            Console.WriteLine();

//            Console.WriteLine("Only XElement, no XText, XComment, ...");
//            Console.WriteLine("-------------------");
//            foreach (var c in contact.Nodes().OfType<XElement>())
//            {
//                Console.WriteLine(c);
//            }
//            Console.WriteLine("-------------------");
//            Console.WriteLine();

//            Console.WriteLine("Same as above");
//            Console.WriteLine("-------------------");
//            foreach (var c in contact.Elements())
//            {
//                Console.WriteLine(c);
//            }
//            Console.WriteLine("-------------------");
//            Console.WriteLine();

//            Console.WriteLine("Simple filter");
//            Console.WriteLine("-------------------");
//            foreach (var c in contact.Elements().Where(e => Regex.IsMatch(e.Value, "[0-9]")))
//            {
//                Console.WriteLine(c);
//            }
//            Console.WriteLine("-------------------");
//            Console.WriteLine();

//            Console.WriteLine("Only XComment");
//            Console.WriteLine("-------------------");
//            foreach (var c in contact.Nodes().OfType<XComment>())
//            {
//                Console.WriteLine(c);
//            }
//            Console.WriteLine("-------------------");
//            Console.WriteLine(); 
            #endregion

            #region Step 9 - Get single Element
//            XElement contact = XElement.Parse(@"<contact>
//                   Met in 2005.
//                   <name>Patrick Hines</name>
//                   <phone>206-555-0144</phone>
//                   <phone>425-555-0145</phone>
//                   <!--Avoid whenever possible-->
//                </contact>");

//            // Element <name> must be single in <contact>!
//            Console.WriteLine(contact.Element("name").Value); 
            #endregion

            #region Step 10 - Manipulating XML
            #region Insert XML
//            XElement contact = XElement.Parse(@"<contact>
//                   <name>Patrick Hines</name>
//                   <phone>206-555-0144</phone>
//                   <phone>425-555-0145</phone>
//                </contact>");

//            XElement mobilePhone1 = new XElement("phone", "111-111-1111");
//            contact.Add(mobilePhone1);
//            Console.WriteLine(contact);
//            Console.WriteLine("----------------------");
//            Console.WriteLine();

//            XElement mobilePhone2 = new XElement("phone", "222-222-2222");
//            XElement firstPhone = contact.Element("phone");
//            firstPhone.AddAfterSelf(mobilePhone2);
//            firstPhone.AddBeforeSelf(mobilePhone2);
//            Console.WriteLine(contact);
//            Console.WriteLine("----------------------");
//            Console.WriteLine();

//            contact.Add(new XElement("address",
//                   new XElement("street", "123 Main St"),
//                   new XElement("city", "Mercer Island"),
//                   new XElement("state", "WA"),
//                   new XElement("country", "USA"),
//                   new XElement("postalCode", "68042")
//                ));
//            Console.WriteLine(contact);
//            Console.WriteLine("----------------------");
//            Console.WriteLine();  
            #endregion

            #region Delete XML
            //contact.Element("phone").Remove();
            //Console.WriteLine(contact);
            //Console.WriteLine("----------------------");
            //Console.WriteLine();

            //contact.Element("address").RemoveNodes();
            //Console.WriteLine(contact);
            //Console.WriteLine("----------------------");
            //Console.WriteLine(); 
            #endregion

            #region Update XML
            //contact.Element("phone").ReplaceNodes("333-333-333");
            //Console.WriteLine(contact);
            //Console.WriteLine("----------------------");
            //Console.WriteLine();

            //contact.Element("address").ReplaceWith(
            //       new XElement("street", "123 Brown Lane"),
            //       new XElement("city", "Redmond"),
            //       new XElement("state", "WA"),
            //       new XElement("country", "USA"),
            //       new XElement("postalCode", "68072")
            //    );
            //Console.WriteLine(contact);
            //Console.WriteLine("----------------------");
            //Console.WriteLine(); 
            #endregion
            #endregion

            #region Step 11 - Attributes
            //#region Adding XML Attributes
            //XElement contact = new XElement("contact",
            //                      new XElement("name", "Patrick Hines"),
            //                      new XElement("phone",
            //                         new XAttribute("type", "home"),
            //                         "206-555-0144"
            //                      ),
            //                      new XElement("phone",
            //                         new XAttribute("type", "work"),
            //                         "425-555-0145"
            //                      )
            //                   );
            //Console.WriteLine(contact);
            //Console.WriteLine("----------------------");
            //Console.WriteLine();  
            //#endregion

            //#region Getting XML Attributes
            //foreach (var p in contact.Elements("phone"))
            //{
            //    if ((string)p.Attribute("type") == "home")
            //        Console.Write("Home phone is: " + (string)p);
            //}
            //Console.WriteLine("----------------------");
            //Console.WriteLine(); 
            //#endregion

            //#region Deleting XML Attributes
            //contact.Elements("phone").First().Attribute("type").Remove();
            //Console.WriteLine(contact);
            //Console.WriteLine("----------------------");
            //Console.WriteLine(); 
            //#endregion
            #endregion

            #region Step 12 - XML Query Extensions
            //XElement contacts = XElement.Load("contacts.xml");
            //// Print phone numbers
            //foreach (XElement x in contacts.Elements("contact").Elements("phone"))
            //{
            //    Console.WriteLine(x.Value);
            //}
            //Console.WriteLine("----------------------");

            //// Get first phone
            //XElement phone = contacts.Descendants("phone").First();
            //// Print parents
            //foreach (XElement a in phone.Ancestors())
            //{
            //    Console.WriteLine(a.Name);
            //};
            //Console.WriteLine("----------------------");


            //// Print parents and self
            //foreach (XElement a in phone.AncestorsAndSelf())
            //{
            //    Console.WriteLine(a.Name);
            //};
            //Console.WriteLine("----------------------");

            //// print all phone types (Lambda and Query Expressions)
            //foreach (var a in contacts.Descendants("phone").Attributes("type").Select(t => t.Value).Distinct())
            //{
            //    Console.WriteLine(a);
            //}
            //Console.WriteLine("----------------------"); 
            #endregion

            #region Step 13 - Transformation
            //XElement contacts = XElement.Load("contacts.xml");
            //XElement customers = new XElement("Customers",
            //   from c in contacts.Elements("contact")
            //   select new XElement("Customer",
            //             new XElement("Name", c.Element("name")),
            //             new XElement("PhoneNumbers",
            //                from ph in c.Elements("phone")
            //                select new XElement("phone", ph.Value, ph.Attribute("type"))
            //             )
            //          )
            //);

            //Console.WriteLine(customers);
            //Console.WriteLine("----------------------"); 
            #endregion

            #region Step 14 - Using Query Expressions with XML
            //// IEnumerable<string>
            //XElement contacts = XElement.Load("contacts.xml");
            //var filtered1 = from c in contacts.Elements("contact")
            //                where (string)c.Element("address").Element("state") == "WA"
            //                orderby (string)c.Element("name")
            //                select (string)c.Element("name");


            //foreach (string name in filtered1)
            //{
            //    Console.WriteLine(name);
            //}
            //Console.WriteLine("----------------------");


            //// IEnumerable<string>
            //var filtered2 = contacts.Elements("contact").Where(c => c.Element("address").Element("state").Value == "WA").OrderBy(c => c.Element("name").Value).Select(c => c.Element("name").Value);
            //foreach (string name in filtered2)
            //{
            //    Console.WriteLine(name);
            //}
            //Console.WriteLine("----------------------");

            //// IEnumerable<XElement>
            //var filtered3 = from c in contacts.Elements("contact")
            //                from ph in c.Elements("phone")
            //                where (string)c.Element("address").Element("state") == "WA" &&
            //                    ph.Value.StartsWith("206")
            //                orderby (string)c.Element("name")
            //                select c;

            //foreach (XElement contact in filtered3)
            //{
            //    Console.WriteLine(contact);
            //}
            //Console.WriteLine("----------------------"); 
            #endregion

            #region Step 15 - Create XML from Database
            //AdventureWorksDataContext db = new AdventureWorksDataContext();

            //XElement products = new XElement("products",
            //                    from p in db.Products
            //                    where p.ListPrice < 100
            //                    orderby p.Name
            //                    select new XElement("product",
            //                           new XAttribute("productId", p.ProductID),
            //                           new XElement("name", p.Name),
            //                           new XElement("code", p.ProductNumber),
            //                           new XElement("price", p.ListPrice)));

            //Console.WriteLine(products);
            //Console.WriteLine("----------------------");
            //Console.WriteLine();  
            #endregion

            #region Step 16 - Join two XMLs
            //AdventureWorksDataContext db = new AdventureWorksDataContext();

            //XElement products = new XElement("products",
            //                    from p in db.Products
            //                    orderby p.Name
            //                    select new XElement("product",
            //                           new XAttribute("productId", p.ProductID),
            //                           new XElement("name", p.Name),
            //                           new XElement("code", p.ProductNumber),
            //                           new XElement("price", p.ListPrice)));

            //XElement orderItems = XElement.Load("order.xml");

            //var orders = from p in products.Elements("product")
            //             from o in orderItems.Elements("orderItem")
            //             where p.Element("code").Value == o.Attribute("number").Value
            //             select new
            //                    {
            //                        Name = p.Element("name").Value,
            //                        Code = p.Element("code").Value,
            //                        Count = Convert.ToInt32(o.Value),
            //                        TotalPrice = Convert.ToInt32(o.Value) * Convert.ToDouble(p.Element("price").Value)
            //                    };

            //foreach (var orderItem in orders)
            //{
            //    Console.WriteLine(String.Format("{0,-25}{1,-10}{2,5} pc. (total price: {3,10:0.00} USD)",
            //                                    orderItem.Name,
            //                                    orderItem.Code,
            //                                    orderItem.Count,
            //                                    orderItem.TotalPrice));
            //}
            #endregion
            
            Console.ReadLine();
        }
    }

    class Person
    {
        private string _name;
        private string[] _phoneNumbers;

        public string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public string[] PhoneNumbers
        {
            get { return _phoneNumbers; }
            set { _phoneNumbers = value; }
        }
    }
}
